"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFieldArrayComponent = void 0;
const React = require("react");
function getFieldArrayComponent(form) {
    class FieldArrayComponent extends React.PureComponent {
        constructor(props) {
            super(props);
            this.fourceUpdateWrapper = () => {
                this.forceUpdate();
            };
            this.componentDidMount = () => {
                this.field.subscribe(this.fourceUpdateWrapper);
            };
            this.componentWillUnmount = () => {
                this.field.unsubscribe(this.fourceUpdateWrapper);
            };
            this.render = () => {
                var _a, _b;
                if (this.field.name !== this.props.name) {
                    this.field.unsubscribe(this.fourceUpdateWrapper);
                    this.field = form.getField(this.props.name);
                    this.field.setDefaultValue([]);
                    this.field.subscribe(this.fourceUpdateWrapper);
                }
                const { push, remove } = this.field;
                const names = ((_a = this.field.value) !== null && _a !== void 0 ? _a : []).map((item, index) => `${this.field.name}[${index}]`);
                const component = (_b = this.props.children) !== null && _b !== void 0 ? _b : this.props.component;
                return component({ names, push, remove });
            };
            this.field = form.getField(props.name);
        }
    }
    Object.defineProperty(FieldArrayComponent, "name", { value: "Field Array" });
    Object.defineProperty(FieldArrayComponent, "displayName", { value: `(${form.name})(Field Array)` });
    return FieldArrayComponent;
}
exports.getFieldArrayComponent = getFieldArrayComponent;
//# sourceMappingURL=FieldArrayComponent.js.map