"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBaseComponent = void 0;
const React = require("react");
function getBaseComponent(form) {
    class BaseComponent extends React.PureComponent {
        constructor(props) {
            super(props);
            this.fourceUpdateWrapper = () => {
                this.forceUpdate();
            };
            this.updateField = (validate, initialValue, defaultValue) => {
                this.field.unsubscribe(this.fourceUpdateWrapper);
                if (this.field.name !== this.props.name)
                    this.field = form.getField(this.props.name);
                this.field.setValidators(validate === undefined ? [] : Array.isArray(validate) ? validate : [validate]);
                this.field.setInitialValue(initialValue);
                this.field.setDefaultValue(defaultValue);
                this.field.subscribe(this.fourceUpdateWrapper);
            };
            this.componentWillUnmount = () => {
                this.field.unsubscribe(this.fourceUpdateWrapper);
            };
            this.field = form.getField(props.name);
        }
    }
    Object.defineProperty(BaseComponent, "name", { value: "Field Base" });
    Object.defineProperty(BaseComponent, "displayName", { value: `(${form.name})(Field Base)` });
    return BaseComponent;
}
exports.getBaseComponent = getBaseComponent;
//# sourceMappingURL=BaseComponent.js.map