"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFieldReaderComponent = void 0;
const React = require("react");
function getFieldReaderComponent(form) {
    class FieldReaderComponent extends React.PureComponent {
        constructor(props) {
            super(props);
            this.fourceUpdateWrapper = () => {
                this.forceUpdate();
            };
            this.componentDidMount = () => {
                this.field.subscribe(this.fourceUpdateWrapper);
            };
            this.componentWillUnmount = () => {
                this.field.unsubscribe(this.fourceUpdateWrapper);
            };
            this.render = () => {
                var _a;
                if (this.field.name !== this.props.name) {
                    this.field.unsubscribe(this.fourceUpdateWrapper);
                    this.field = form.getField(this.props.name);
                    this.field.subscribe(this.fourceUpdateWrapper);
                }
                const { value } = this.field;
                const component = (_a = this.props.children) !== null && _a !== void 0 ? _a : this.props.component;
                return component({ value });
            };
            this.field = form.getField(props.name);
        }
    }
    Object.defineProperty(FieldReaderComponent, "name", { value: "Field Reader" });
    Object.defineProperty(FieldReaderComponent, "displayName", { value: `(${form.name})(Field Reader)` });
    return FieldReaderComponent;
}
exports.getFieldReaderComponent = getFieldReaderComponent;
//# sourceMappingURL=FieldReaderComponent.js.map