"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFormComponent = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const React = require("react");
function getFormComponent(form) {
    class FormComponent extends React.PureComponent {
        constructor() {
            super(...arguments);
            this.updateFormParams = () => {
                if (this.props.onSubmit !== undefined)
                    form.onSubmit = this.props.onSubmit;
            };
            this.onSubmit = (event) => {
                event.preventDefault();
                form.submit();
            };
            this.componentDidMount = () => {
                this.updateFormParams();
            };
            this.componentDidUpdate = () => {
                this.updateFormParams();
            };
            this.render = () => {
                const _a = this.props, { onSubmit } = _a, props = __rest(_a, ["onSubmit"]);
                return (0, jsx_runtime_1.jsx)("form", Object.assign({}, props, { id: form.name, onSubmit: this.onSubmit }));
            };
        }
    }
    Object.defineProperty(FormComponent, "name", { value: "Form" });
    Object.defineProperty(FormComponent, "displayName", { value: `(${form.name})(Form)` });
    return FormComponent;
}
exports.getFormComponent = getFormComponent;
//# sourceMappingURL=FormComponent.js.map