/// <reference types="react" />
import { Validator, Subscriber } from "../types";
import { Form } from "./form";
type InputProps = {
    name: string;
    onChange: (event: React.ChangeEvent<HTMLInputElement>) => void;
    onFocus: (event: React.FocusEvent<HTMLInputElement>) => void;
    onBlur: (event: React.FocusEvent<HTMLInputElement>) => void;
    value: any;
};
export declare class Field {
    readonly form: Form;
    readonly name: string;
    validators: Validator[];
    errors: string[];
    initialValue: any;
    defaultValue: any;
    value: any;
    active: boolean;
    visited: boolean;
    touched: boolean;
    submitFailed: boolean;
    inputProps: InputProps;
    private subscribers;
    constructor(form: Form, name: string, initialValue: any);
    setValidators: (validators: Validator[]) => void;
    setSubmissionErrors: (errors: string[]) => void;
    setInitialValue: (value: any) => void;
    setDefaultValue: (value: any) => void;
    validate: () => boolean;
    focus: () => void;
    change: (value: any) => void;
    blur: () => void;
    reset: () => void;
    push: (value?: any) => void;
    private getKeysListsFlags;
    private import;
    remove: (index: number) => void;
    subscribe: (subscriber: Subscriber) => void;
    unsubscribe: (subscriber: Subscriber) => void;
    trigger: () => void;
}
export {};
//# sourceMappingURL=field.d.ts.map