import * as components from "../components";
import { DeepPartial, DeepReadonlyPartial, Subscriber } from "../types";
import { Field } from "./field";
export declare class Form<T = {}> {
    readonly name: string;
    readonly Form: ReturnType<typeof components.getFormComponent>;
    readonly Submit: ReturnType<typeof components.getSubmitComponent>;
    readonly Reset: ReturnType<typeof components.getResetComponent>;
    readonly Field: ReturnType<typeof components.getFieldComponent>;
    readonly Input: ReturnType<typeof components.getInputComponent>;
    readonly FieldArray: ReturnType<typeof components.getFieldArrayComponent>;
    readonly FieldReader: ReturnType<typeof components.getFieldReaderComponent>;
    onSubmit?: (values: DeepReadonlyPartial<T>) => void;
    private values;
    private fields;
    private subscribers;
    constructor(name?: string);
    getKeys: () => IterableIterator<string>;
    valueExists: (path: string) => boolean;
    getValue: (path: string) => any;
    setValue: (path: string, value: any) => void;
    private initializeArraysInner;
    private initializeArrays;
    setValues: (values: any) => void;
    setSubmissionErrors: (errors: Object) => void;
    getField: (name: string) => Field;
    removeField: (name: string) => boolean;
    getValues: () => DeepReadonlyPartial<T>;
    reset: () => void;
    private checkCanSubmit;
    submit: (callback?: ((values: DeepReadonlyPartial<T>) => void) | undefined) => boolean;
    subscribe: (subscriber: Subscriber<DeepPartial<T>>) => void;
    unsubscribe: (subscriber: Subscriber<DeepPartial<T>>) => void;
    trigger: () => void;
}
//# sourceMappingURL=form.d.ts.map