"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSubscribable = void 0;
const react_1 = require("react");
function useSubscribable(subscribable, initialValue) {
    const [value, setValue] = (0, react_1.useState)(initialValue);
    const tempValue = (0, react_1.useRef)(value);
    const flag = (0, react_1.useRef)(false);
    const setTempValue = (value) => {
        tempValue.current = value;
    };
    (0, react_1.useEffect)(() => {
        subscribable.subscribe(setValue);
        return () => {
            subscribable.unsubscribe(setValue);
        };
    });
    (0, react_1.useEffect)(() => {
        subscribable.unsubscribe(setTempValue);
        if (tempValue.current !== value)
            setValue(tempValue.current);
    }, []);
    if (flag.current === false) {
        subscribable.subscribe(setTempValue);
        flag.current = true;
    }
    return value;
}
exports.useSubscribable = useSubscribable;
//# sourceMappingURL=useSubscribable.js.map