/// <reference types="react" />
import { PromiseExt } from "@0x2e757/promise-ext";
export { PromiseExt };
import { IWrapper, StaticWrapper, IStaticWrapper, DynamicWrapper, IDynamicWrapper } from "@0x2e757/wrappers";
export type { IWrapper, IStaticWrapper, IDynamicWrapper };
export { StaticWrapper, DynamicWrapper };
import { Constructor, ISubscribable } from "./types";
export type { Constructor, ISubscribable };
import { Form, Field } from "./forms";
export { Form, Field };
import { subscribe } from "./decorators";
export { subscribe };
import { useWrapper, useSubscribable, useForm } from "./hooks";
export { useWrapper, useSubscribable, useForm };
declare const _default: {
    PromiseExt: typeof PromiseExt;
    StaticWrapper: new <T>(value: T) => IStaticWrapper<T>;
    DynamicWrapper: new <T_1, U extends unknown[]>(...args: [...wrappers: import("@0x2e757/wrappers/build/types").IWrappers<U>, emitter: import("@0x2e757/wrappers/build/types").Emitter<T_1, U>]) => IDynamicWrapper<T_1>;
    Form: typeof Form;
    Field: typeof Field;
    subscribe: (...subscribables: ISubscribable<any>[]) => <T_2 extends Constructor<import("react").Component<{}, {}, any>>>(component: T_2) => T_2;
    useWrapper: typeof useWrapper;
    useSubscribable: typeof useSubscribable;
    useForm: typeof useForm;
};
export default _default;
//# sourceMappingURL=index.d.ts.map