"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lowerCaseKeys = exports.flattenErrorsObject = exports.flattenObject = exports.uuid = exports.remove = exports.set = exports.get = exports.exists = void 0;
var object_1 = require("./object");
Object.defineProperty(exports, "exists", { enumerable: true, get: function () { return object_1.exists; } });
Object.defineProperty(exports, "get", { enumerable: true, get: function () { return object_1.get; } });
Object.defineProperty(exports, "set", { enumerable: true, get: function () { return object_1.set; } });
Object.defineProperty(exports, "remove", { enumerable: true, get: function () { return object_1.remove; } });
function uuid() {
    const result = new Array(36);
    const hexDigits = "0123456789abcdef";
    for (var i = 0; i < 36; i++) {
        result[i] = hexDigits[Math.floor(Math.random() * 0x10)];
    }
    result[14] = "4";
    result[19] = hexDigits[(Number(result[19]) & 0x3) | 0x8];
    result[8] = result[13] = result[18] = result[23] = "-";
    return result.join("");
}
exports.uuid = uuid;
function flattenObjectInner(object, propertyName, result = {}) {
    if (typeof object === "object")
        flattenObject(object, propertyName, result);
    else
        result[propertyName] = object;
}
function flattenObject(object, parentPropertyName, result = {}) {
    if (Array.isArray(object))
        for (let index = 0; index < object.length; index += 1) {
            const propertyName = parentPropertyName ? `${parentPropertyName}[${index}]` : `[${index}]`;
            flattenObjectInner(object[index], propertyName, result);
        }
    else
        for (const key in object) {
            const propertyName = parentPropertyName ? `${parentPropertyName}.${key}` : key;
            flattenObjectInner(object[key], propertyName, result);
        }
    return result;
}
exports.flattenObject = flattenObject;
function flattenErrorsObjectInner(object, propertyName, result = {}) {
    if (typeof object === "object")
        if (Array.isArray(object) && typeof object[0] === "string")
            result[propertyName] = object;
        else
            flattenErrorsObject(object, propertyName, result);
    else
        result[propertyName] = object;
}
function flattenErrorsObject(object, parentPropertyName, result = {}) {
    if (Array.isArray(object))
        for (let index = 0; index < object.length; index += 1) {
            const propertyName = parentPropertyName ? `${parentPropertyName}[${index}]` : `[${index}]`;
            flattenErrorsObjectInner(object[index], propertyName, result);
        }
    else
        for (const key in object) {
            const propertyName = parentPropertyName ? `${parentPropertyName}.${key}` : key;
            flattenErrorsObjectInner(object[key], propertyName, result);
        }
    return result;
}
exports.flattenErrorsObject = flattenErrorsObject;
function lowerCaseKeys(object) {
    const result = {};
    for (const key in object)
        result[key.toLowerCase()] = object[key];
    return result;
}
exports.lowerCaseKeys = lowerCaseKeys;
//# sourceMappingURL=index.js.map